<template>
  <div class="i-secure-account" :class="{ 'i-secure-account--shown': isShown }">
    <div class="i-secure-account__background"></div>
    <div class="i-secure-account__wrapper">
      <form class="i-secure-account__content" @submit.prevent="submit()">
        <div class="i-secure-account__title">Secure Your Account</div>
        <div class="i-secure-account__description">Please, enter and confirm your password to secure your account.</div>
        <i-input
          ref="passwordInput"
          v-model="user.password"
          type="password"
          placeholder="Enter your password"
          class="mt-3" />
        <i-input
          ref="passwordConfirmationInput"
          v-model="user.passwordConfirmation"
          type="password"
          placeholder="Confirm your password"
          class="mt-1" />
        <i-button block submit :loading="isLoading" :disabled="isLoading" class="mt-1 mb-3">Save</i-button>
      </form>
    </div>
  </div>
</template>

<script>
  import { mapState } from 'vuex';

  export default {
    data() {
      return {
        user: {
          password: null,
          passwordConfirmation: null,
        },
        isLoading: false,
        isShown: false,
      };
    },

    computed: {
      ...mapState(['auth']),
    },

    watch: {
      'auth.user.unlockFullAccessClosedAt'(value) {
        if (value && this.auth.user.authMethod === 'EMAIL' && !this.auth.user.hasPassword) {
          setTimeout(() => {
            this.show();
          }, 250);
        }
      },
    },

    mounted() {
      if (this.auth.user.authMethod === 'EMAIL' && !this.auth.user.hasPassword) {
        if (this.auth.user.unlockFullAccessClosedAt) {
          setTimeout(() => {
            this.show();
          }, 250);
        }
      }
    },

    methods: {
      show() {
        this.isShown = true;

        setTimeout(() => {
          this.$refs.passwordInput.$refs.input.focus();
        }, 100);
      },

      hide() {
        this.isShown = false;
        this.isLoading = false;
      },

      async submit() {
        if (!this.user.password) {
          this.$refs.passwordInput.$refs.input.focus();
          this.$refs.passwordInput.$refs.root.classList.add('bounce');

          setTimeout(() => {
            this.$refs.passwordInput.$refs.root.classList.remove('bounce');
          }, 1000);

          return;
        }

        if (this.user.passwordConfirmation !== this.user.password) {
          this.$refs.passwordConfirmationInput.$refs.input.focus();
          this.$refs.passwordConfirmationInput.$refs.root.classList.add('bounce');

          setTimeout(() => {
            this.$refs.passwordConfirmationInput.$refs.root.classList.remove('bounce');
          }, 1000);

          return;
        }

        this.isLoading = true;

        try {
          let response = await this.$axios.post(`auth/password/change`, {
            user: {
              password: this.user.password,
            },
          });

          this.$store.commit('MERGE_AUTH', response.data.data);
          this.hide();
        } catch (error) {
          this.isLoading = false;
          console.error(error);
        }
      },
    },
  };
</script>

<style lang="scss">
  .i-secure-account {
    position: fixed;
    z-index: 1000;
    top: 0;
    right: 0;
    bottom: 0;
    left: 0;
    display: flex;
    align-items: flex-end;
    justify-content: center;
    visibility: visible;
    opacity: 1;
    transition: visibility 0.25s ease-in, opacity 0.25s ease-in;

    &:not(&--shown) {
      visibility: hidden;
      opacity: 0;
    }
  }

  .i-secure-account__background {
    position: absolute;
    z-index: 1;
    top: 0;
    right: 0;
    left: 0;
    bottom: 0;
    background-color: rgba(#07071c, 50%);
  }

  .i-secure-account__wrapper {
    position: relative;
    z-index: 2;
    display: flex;
    flex-direction: column;
    width: 100%;
    max-height: 100%;
    overflow-y: auto;
    transform: translateY(0);
    transition: transform 0.25s ease-in;
  }

  .i-secure-account:not(.i-secure-account--shown) .i-secure-account__wrapper {
    transform: translateY(100%);
  }

  .i-secure-account__content {
    position: relative;
    width: 100%;
    max-width: 480px;
    border-top-left-radius: rs(16px);
    border-top-right-radius: rs(16px);
    background-color: #fff;
    margin: 0 auto;
    padding: 0 rs(32px);
  }

  .i-secure-account__title {
    font-size: rf(24px);
    color: #07071c;
    font-weight: bold;
    margin-top: rs(25px);
    text-align: center;
  }

  .i-secure-account__description {
    text-align: center;
    font-size: rf(16px);
    color: #fb7474;
    font-weight: bold;
    margin-top: rs(44px);
    margin-bottom: rs(44px);
  }
</style>
